题目描述
这是 LeetCode 上的 2300. 咒语和药水的成功对数 ,难度为 中等。
Tag : 「排序」、「二分」
给你两个正整数数组 spells
和 potions
,长度分别为 n
和 m
,其中 spells[i]
表示第 i
个咒语的能量强度,potions[j]
表示第 j
瓶药水的能量强度。
同时给你一个整数 success
。一个咒语和药水的能量强度相乘如果大于等于 success
,那么它们视为一对成功的组合。
请你返回一个长度为 n
的整数数组 pairs
,其中 pairs[i]
是能跟第 i
个咒语成功组合的 药水 数目。
示例 1:
css
输入:spells = [5,1,3], potions = [1,2,3,4,5], success = 7
输出:[4,0,3]
解释:
- 第 0 个咒语:5 * [1,2,3,4,5] = [5,10,15,20,25] 。总共 4 个成功组合。
- 第 1 个咒语:1 * [1,2,3,4,5] = [1,2,3,4,5] 。总共 0 个成功组合。
- 第 2 个咒语:3 * [1,2,3,4,5] = [3,6,9,12,15] 。总共 3 个成功组合。
所以返回 [4,0,3] 。
示例 2:
css
输入:spells = [3,1,2], potions = [8,5,8], success = 16
输出:[2,0,2]
解释:
- 第 0 个咒语:3 * [8,5,8] = [24,15,24] 。总共 2 个成功组合。
- 第 1 个咒语:1 * [8,5,8] = [8,5,8] 。总共 0 个成功组合。
- 第 2 个咒语:2 * [8,5,8] = [16,10,16] 。总共 2 个成功组合。
所以返回 [2,0,2] 。
提示:
- <math xmlns="http://www.w3.org/1998/Math/MathML"> n = s p e l l s . l e n g t h n = spells.length </math>n=spells.length
- <math xmlns="http://www.w3.org/1998/Math/MathML"> m = p o t i o n s . l e n g t h m = potions.length </math>m=potions.length
- <math xmlns="http://www.w3.org/1998/Math/MathML"> 1 < = n , m < = 1 0 5 1 <= n, m <= 10^5 </math>1<=n,m<=105
- <math xmlns="http://www.w3.org/1998/Math/MathML"> 1 < = s p e l l s [ i ] , p o t i o n s [ i ] < = 1 0 5 1 <= spells[i], potions[i] <= 10^5 </math>1<=spells[i],potions[i]<=105
- <math xmlns="http://www.w3.org/1998/Math/MathML"> 1 < = s u c c e s s < = 1010 1 <= success <= 1010 </math>1<=success<=1010
排序 + 二分
为了方便,我们将 spells
记为 a
,将 potions
记为 b
,将 success
记为 t
。
对于每个 <math xmlns="http://www.w3.org/1998/Math/MathML"> a [ i ] a[i] </math>a[i],有多少个 <math xmlns="http://www.w3.org/1998/Math/MathML"> b [ j ] b[j] </math>b[j] 满足 <math xmlns="http://www.w3.org/1998/Math/MathML"> a [ i ] × b [ j ] ⩾ t a[i] \times b[j] \geqslant t </math>a[i]×b[j]⩾t,等价于问数组 b
中值大于等于 <math xmlns="http://www.w3.org/1998/Math/MathML"> t a [ i ] \frac{t}{a[i]} </math>a[i]t 的个数,这容易让我们想到先对数组 b
排升序,再通过二分找到满足该条件的最小下标,从该下标到数组结尾,均为满足条件的 <math xmlns="http://www.w3.org/1998/Math/MathML"> b [ j ] b[j] </math>b[j]。
Java 代码:
Java
class Solution {
public int[] successfulPairs(int[] a, int[] b, long t) {
int n = a.length, m = b.length;
int[] ans = new int[n];
Arrays.sort(b);
for (int i = 0; i < n; i++) {
double cur = t * 1.0 / a[i];
int l = 0, r = m - 1;
while (l < r) {
int mid = l + r >> 1;
if (b[mid] >= cur) r = mid;
else l = mid + 1;
}
if (b[r] * 1L * a[i] >= t) ans[i] = m - r;
}
return ans;
}
}
Python 代码:
Python
class Solution:
def successfulPairs(self, a: List[int], b: List[int], t: int) -> List[int]:
# n, m = len(a), len(b)
# b.sort()
# ans = [0] * n
# for i in range(n):
# cur = t / a[i]
# l, r = 0, m - 1
# while l < r:
# mid = l + r >> 1
# if b[mid] >= cur: r = mid
# else: l = mid + 1
# ans[i] = m - r if b[r] * a[i] >= t else 0
# return ans
b.sort()
return [len(b) - bisect_left(b, t / x) for x in a]
C++ 代码:
C++
class Solution {
public:
vector<int> successfulPairs(vector<int>& a, vector<int>& b, long long t) {
// int n = a.size(), m = b.size();
// vector<int> ans(n);
// sort(b.begin(), b.end());
// for (int i = 0; i < n; i++) {
// double cur = t * 1.0 / a[i];
// int l = 0, r = m - 1;
// while (l < r) {
// int mid = l + r >> 1;
// if (b[mid] >= cur) r = mid;
// else l = mid + 1;
// }
// if (b[r] * 1L * a[i] >= t) ans[i] = m - r;
// }
// return ans;
int n = a.size(), m = b.size();
vector<int> ans(n);
sort(b.begin(), b.end());
for (int i = 0; i < n; i++) ans[i] = b.end() - lower_bound(b.begin(), b.end(), t * 1.0 / a[i]);
return ans;
}
};
TypeScript 代码:
TypeScript
function successfulPairs(a: number[], b: number[], t: number): number[] {
const n = a.length, m = b.length;
const ans = new Array(n).fill(0);
b.sort((a,b)=>a-b);
for (let i = 0; i < n; i++) {
const cur = t * 1.0 / a[i];
let l = 0, r = m - 1;
while (l < r) {
const mid = l + r >> 1;
if (b[mid] >= cur) r = mid;
else l = mid + 1;
}
if (b[r] * a[i] >= t) ans[i] = m - r;
}
return ans;
};
- 时间复杂度:对数组
b
排序的复杂度为 <math xmlns="http://www.w3.org/1998/Math/MathML"> O ( m log m ) O(m\log{m}) </math>O(mlogm);构建答案时,每次在值域 <math xmlns="http://www.w3.org/1998/Math/MathML"> [ 0 , m − 1 ] [0, m - 1] </math>[0,m−1] 范围内进行二分,复杂度为 <math xmlns="http://www.w3.org/1998/Math/MathML"> O ( n log m ) O(n\log{m}) </math>O(nlogm)。整体复杂度为 <math xmlns="http://www.w3.org/1998/Math/MathML"> O ( m log m + n log m ) O(m\log{m} + n\log{m}) </math>O(mlogm+nlogm) - 空间复杂度: <math xmlns="http://www.w3.org/1998/Math/MathML"> O ( log m + n ) O(\log{m} + n) </math>O(logm+n)
最后
这是我们「刷穿 LeetCode」系列文章的第 No.2300
篇,系列开始于 2021/01/01,截止于起始日 LeetCode 上共有 1916 道题目,部分是有锁题,我们将先把所有不带锁的题目刷完。
在这个系列文章里面,除了讲解解题思路以外,还会尽可能给出最为简洁的代码。如果涉及通解还会相应的代码模板。
为了方便各位同学能够电脑上进行调试和提交代码,我建立了相关的仓库:github.com/SharingSour... 。
在仓库地址里,你可以看到系列文章的题解链接、系列文章的相应代码、LeetCode 原题链接和其他优选题解。
更多更全更热门的「笔试/面试」相关资料可访问排版精美的 合集新基地 🎉🎉